<!-- --COPYRIGHT--,BSD
 *  Copyright (c) 2012, Texas Instruments Incorporated
 *  All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 * 
 *  *  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 
 *  *  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 
 *  *  Neither the name of Texas Instruments Incorporated nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT-- -->
<html>
<head data-gc-version='1.0.0001'>
	<meta charset='utf-8'>
	<title>Configuration</title>
	
	<!-- Dojo library -->
	<script src='lib/dojo/dojo/dojo.js'	data-dojo-config="'parseOnLoad':true, async:true, 'packages':[{'name':'gc','location':'../../gc'}]"></script>

	<!-- jQuery library -->	
	<link rel='stylesheet' href='lib/gc/dijit/libs/css/ui-darkness/jquery-ui.css'>
	<link rel='stylesheet' href='lib/gc/dijit/libs/css/jquery.combobox.css'>	
	<script src='lib/gc/dijit/libs/jquery.min.js'></script>
	<script src='lib/gc/dijit/libs/jquery-ui.min.js'></script>
	<script src='lib/gc/dijit/libs/plugins/jquery.combobox.js'></script>
	
	<!-- GUI Composer library -->
	<script src="lib/gc/backplane/guiComposer.js"></script>

	<script>
		window.targetConnection = null;
		window.targetDevice = null;
	
		$(function() {
			_initConnections();
			$('#restart').button();
			
			$('#console').val(parent.CONSOLE_TEXT);
			_setConsoleHeight();
		});
		
		/*
		 * Sets the height of the console widget.
		 */
		function _setConsoleHeight() {
			$('#console').height($(window).height() - 70)
		}
		
		/*
		 * Initialize the available connections combo-box.
		 */
		function _initConnections() {
			var connection = $('#connection');
			var connectionLabel = $('#connectionLabel');
			var restart = $('#restart');
			
			$.getJSON('.appsettings', function(data) {
				if (data.default) {
					window.targetConnection = data.default.connection;
					window.targetDevice = data.default.device;
				}
			
				if (data.connections) {
					$.each(data.connections, function(key, val) {
						connection.append('<option value=\'' + val + '\'>' + val + '</option>');
						if (val === data.default.connection) {
							connection.val(val);							
						}
					});
					
					
					connection.combobox({
						selected: function(event, ui) {
							window.targetConnection = ui.item.value;
						}
					});
				
					$('#toggle').click(function() {
						connection.toggle();
					});
				}
			})
			.error(function() {
				connection.append('<option value=\'None\'>None</option>');
				connection.attr('disabled', true);
				connection.hide();
				connectionLabel.hide();
				restart.css('float', 'right');
				restart.css('font-size', '90%');
			})
			.complete(function() {
				
			});
		}
		
		/*
		 * Register console widget binding.
		 */
		function _registerConsoleWidgetBindingProxy() {
			var proxy = {
				get: function(property) {
					return null;
				},
				
				set: function(property, value) {
					var console = $('#console');
					parent.CONSOLE_TEXT = console.val() + value; 
					console.val(parent.CONSOLE_TEXT);
				},
				
				watch: function(property, listener) {
					// do nothing
				},
			};
		
			$TI.guiComposerServer.registerWidget(proxy, 'appConsole');
			$TI.guiComposerServer.addBinding('appConsole', 'value', 'value:pm.$logger.last_message', {datatype: 'string', defaultValue: null});
		}
		
		/*
		 * Initialize the backend server.
		 */
		function _initServer() {
			var handler = function(result, oprationId) {
				$('#restart').attr('disabled', false);
				
				// if there was a initialization error do not auto swtich to the application page. 
				if( result && result.status && result.status.type == "ERROR") {
					return;
				} 
				
				if (parent.AUTO_SWITCH_APP_PAGE) {
					parent.AUTO_SWITCH_APP_PAGE = false;
					parent.switchToPage('app');
				}
			};
			
			$('#console').val('');
			$('#restart').attr('disabled', true);			
			$TI.guiComposerServer.executeAsynchOperation('value:pm.$init', {connection: window.targetConnection, device: window.targetDevice}, handler, null);
		};
		
		dojo.ready(function() {
			_registerConsoleWidgetBindingProxy();
			if (parent.AUTO_INIT_SERVER) {
				parent.AUTO_INIT_SERVER = false;
				_initServer();
			}
		});
	</script>
</head>

<body  style='font-size: 70%;' onresize='_setConsoleHeight()'>
	<div class='ui-widget' style='white-space:nowrap;'>
		<label id='connectionLabel' style='font-size:medium; font-weight:bold;'>Available Connections: </label>
		<select id='connection'></select>
		<button id='restart' style='margin-left: 50px;' onClick='_initServer()'>Initialize Target</button>
	</div>
	
	<div class='ui-widget'>
		<label style='font-size:medium; font-weight:bold;'>Console Output:</label><br>
		<textarea id='console' readonly='readonly' style='width:100%; resize:none;'></textarea>
	</div>
</body>
</html>
